#include "dsp.h"
#include <stdio.h>

void MyInitWinKaiser (ptFloat pfWindow, tInt iBeta, tInt iN)
{
    tInt iCnt1;
    float scalefactor;
    float tmp=0;
    
    for (iCnt1 = 0; iCnt1 < iN; ++iCnt1)
    {
	pfWindow[iCnt1] = Bessel_Io (2 * iBeta * sqrt (iCnt1 /
				    (tFloat) (iN - 1) - pow (iCnt1 /
				    (tFloat) (iN - 1), 2)), 10) /
	                             Bessel_Io ((tFloat) (iBeta), 10);
    }

    for (iCnt1 = 0; iCnt1 < iN; ++iCnt1)
      tmp+=pfWindow[iCnt1];
    
    scalefactor =((float) iN)/((float) tmp);
    
    for (iCnt1 = 0; iCnt1 < iN; ++iCnt1)
      pfWindow[iCnt1] *= scalefactor;
}

void MyInitWinBlackman (ptFloat pfWindow, tInt iN)
{
    tInt iCnt1;
    for (iCnt1 = 0; iCnt1 < iN; ++iCnt1)
    {
	pfWindow[iCnt1] = 2.38*(0.42 - 0.50 * cos ((2 * M_PI * iCnt1) / (iN - 1))
	  + 0.08 * cos ((4 * M_PI * iCnt1) / (iN - 1)));
    }
}

void MyInitWinRectangle (ptFloat pfWindow, tInt iN)
{
    tInt iCnt1;
    for (iCnt1 = 0; iCnt1 < iN; ++iCnt1)
    {
	pfWindow[iCnt1] = 1;
    }
}
